"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PopupMenu = void 0;
exports.showPopupMenu = showPopupMenu;

var _reactNative = require("react-native");

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const ComponentName = 'PopupMenuView';
let RCTPopupMenuView = _reactNative.UIManager.getViewManagerConfig(ComponentName) != null ? (0, _reactNative.requireNativeComponent)(ComponentName) : null;
const IS_ANDROID = _reactNative.Platform.OS === 'android';

if (IS_ANDROID && !RCTPopupMenuView) {
  throw new Error(`The package '@popupmenu/react-native-popup-menu' doesn't seem to be linked. Make sure: \n\n` + _reactNative.Platform.select({
    ios: "- You have run 'pod install'\n",
    default: ''
  }) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo managed workflow\n');
}

const PopupMenu = /*#__PURE__*/(0, _react.forwardRef)((props, ref) => {
  return IS_ANDROID ?
  /*#__PURE__*/
  // @ts-ignore
  _react.default.createElement(RCTPopupMenuView, _extends({}, props, {
    ref: ref
  })) : /*#__PURE__*/_react.default.createElement(_reactNative.View, _extends({}, props, {
    ref: ref
  }));
});
exports.PopupMenu = PopupMenu;

function showPopupMenu(popupMenuRef, anchorRef) {
  const popNode = (0, _reactNative.findNodeHandle)(popupMenuRef.current);

  if (popNode === null) {
    console.error(`Cannot find PopupMenu node, did you forget to set ref to PopupMenu?`);
    return;
  }

  const anchorNode = (0, _reactNative.findNodeHandle)(anchorRef.current);

  if (anchorNode === null) {
    console.error(`Cannot find anchor node, did you forget to set ref to anchor?`);
    return;
  }

  _reactNative.UIManager.dispatchViewManagerCommand(popNode, 'show', [anchorNode]);
}
//# sourceMappingURL=index.js.map