function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { requireNativeComponent, UIManager, Platform, findNodeHandle, View } from 'react-native';
import React, { forwardRef } from 'react';
const ComponentName = 'PopupMenuView';
let RCTPopupMenuView = UIManager.getViewManagerConfig(ComponentName) != null ? requireNativeComponent(ComponentName) : null;
const IS_ANDROID = Platform.OS === 'android';

if (IS_ANDROID && !RCTPopupMenuView) {
  throw new Error(`The package '@popupmenu/react-native-popup-menu' doesn't seem to be linked. Make sure: \n\n` + Platform.select({
    ios: "- You have run 'pod install'\n",
    default: ''
  }) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo managed workflow\n');
}

export const PopupMenu = /*#__PURE__*/forwardRef((props, ref) => {
  return IS_ANDROID ?
  /*#__PURE__*/
  // @ts-ignore
  React.createElement(RCTPopupMenuView, _extends({}, props, {
    ref: ref
  })) : /*#__PURE__*/React.createElement(View, _extends({}, props, {
    ref: ref
  }));
});
export function showPopupMenu(popupMenuRef, anchorRef) {
  const popNode = findNodeHandle(popupMenuRef.current);

  if (popNode === null) {
    console.error(`Cannot find PopupMenu node, did you forget to set ref to PopupMenu?`);
    return;
  }

  const anchorNode = findNodeHandle(anchorRef.current);

  if (anchorNode === null) {
    console.error(`Cannot find anchor node, did you forget to set ref to anchor?`);
    return;
  }

  UIManager.dispatchViewManagerCommand(popNode, 'show', [anchorNode]);
}
//# sourceMappingURL=index.js.map